import type { Method } from './types';
import SimpleResource from './SimpleResource';
/**
 * Represents an entity to be retrieved from a server.
 * Typically 1:1 with a url endpoint.
 */
export default abstract class Resource extends SimpleResource {
    /** A function to mutate all request options for fetch */
    static fetchOptionsPlugin?: (options: RequestInit) => RequestInit;
    /** Init options for fetch - run at fetch */
    static getFetchInit(init: Readonly<RequestInit>): RequestInit;
    /** Perform network request and resolve with HTTP Response */
    static fetchResponse(method: Method, url: string, body?: Readonly<object | string>): Promise<Response>;
    /** Perform network request and resolve with json body */
    static fetch(method: Method, url: string, body?: Readonly<object | string>): Promise<any>;
}
//# sourceMappingURL=Resource.d.ts.map